#ifndef COMMANDS_H
#define COMMANDS_H

#include <tcl.h>

int Tcl_CmdQuit(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdServer(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdMessageBox(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdInputDialog(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdFileDialog(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdUser(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdIgnore(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdPlay(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdConfigFile(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdChat(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdHint(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdTimer(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdEvent(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdMsg(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdStatus(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdConsole(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdListBox(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdMenu(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdConfig(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdUserMenu(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdPopup(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdParse(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdDescriptions(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdSearch(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);
int Tcl_CmdHistory(void* clientData, Tcl_Interp *interp, int argc, const char *argv[]);

#endif
