# Firewall ver. 0.5c - skrypt ktory filtruje wiadomosci od anonimow


# Dodawanie zakladki do okna konfiguracji.
if { ![config exists Firewall] } {
config newtab Firewall $module(scriptpath)/firewall.png

config add -type checkbox -tab Firewall -caption "Firewall wlaczony" -var firewall_enabled -default 1

config add -type vbox -tab Firewall -caption "Automatyczne pytanie"
config add -type text -tab Firewall -caption "Tekst pytania " -var question -parent "Automatyczne pytanie" -default "Ta wiadomo zostaa wysana do Ciebie AUTOMATYCZNIE!\nNie mam Ci na licie kontaktw i dlatego aby ze mn pogada musisz wpisa haso - wyraz zbudowany z pierwszych liter kadego wyrazu, ze zdania\n\n\"Litwo, ojczyzno moja, ty jeste jak zdrowie\"\n\n (wielko liter nie ma znaczenia)" -hint "Do nieznajomego zostanie wyslana wiadomosc o nastepujacej tresci."
config add -type checkbox -tab Firewall -caption "Zadaj pytanie tylko raz" -var ask_once -parent "Automatyczne pytanie" -default 0
config add -type lineedit -tab Firewall -caption "Odpowiedz " -var answer -parent "Automatyczne pytanie" -default "lomtjjz" -hint "Prawidlowa odpowiedz na powyzsze pytanie"

config add -type vbox -tab Firewall -caption "Po dobrej odpowiedzi"

config add -type grid -tab Firewall -caption "Potwierdzenie_grid" -parent "Po dobrej odpowiedzi" -cols 2
config add -type checkbox -tab Firewall -caption "Wyslij potwierdzenie" -var confirmation_send -parent "Potwierdzenie_grid" -default 1
config add -type lineedit -tab Firewall -caption "o tresci: " -var confirmation_text -parent "Potwierdzenie_grid" -default "OK. Odpowied poprawna, teraz sucham ;-)"

config add -type grid -tab Firewall -caption "Akcja_grid" -parent "Po dobrej odpowiedzi" -cols 3
config add -type combobox -tab Firewall -caption "Podejmij akcje: " -var action -options "{Dodaj do grupy} {Otworz okno rozmowy}" -values "addgroup  openchat" -parent "Akcja_grid" -default "openchat"
config add -type label -tab Firewall -caption "       " -parent "Akcja_grid"; #trzy spacje
config add -type lineedit -tab Firewall -caption "Nazwa grupy " -var groupname -parent "Akcja_grid" -default "Nieznajomi" -hint "Puste pole oznacza dodanie do grupy \"Wszyscy\"!\n Opcja dziala TYLKO gdy obok wybierzesz akcje \"Dodaj do grupy\""

config add -type vbox -tab Firewall -caption "Powiadamianie dymkiem"
config add -type grid -tab Firewall -caption "Hints_grid" -parent "Powiadamianie dymkiem" -cols 3
config add -type checkbox -tab Firewall -caption "Powiadom dymkiem o aktywnosci" -var notify_hint -parent "Hints_grid" -default 1 -hint "Jesli nadejdzie wiadomosc od anonima to zostanie wyswietlony dymek z informacja"
config add -type label -tab Firewall -caption " " -parent "Hints_grid"; #jedna spacja
config add -type spinbox -tab Firewall -caption "Wyswietlaj dymek przez ... sekund: " -var notify_hint_timeout -parent "Hints_grid" -min 1 -max 15 -step 1 -default 3
config add -type colorbutton -tab Firewall -caption "Kolor tekstu dymka" -var notify_hint_fgcolor -parent "Hints_grid" -default navy
config add -type label -tab Firewall -caption "  " -parent "Hints_grid"; #dwie spacje
config add -type colorbutton -tab Firewall -caption "Kolor tla dymka" -var notify_hint_bgcolor -parent "Hints_grid" -default lightblue
config add -type lineedit -tab Firewall -caption "Tekst dymka: " -var notify_hint_text -parent "Powiadamianie dymkiem" -default "Anonim <b>%u</b> przysa wiadomo" -hint "%u - numer GG rozmowcy\nMozna stosowac znaczniki HTML."

config add -type vbox -tab Firewall -caption "Logowanie"
config add -type grid -tab Firewall -caption "Logowanie_grid" -parent "Logowanie" -cols 2
config add -type checkbox -tab Firewall -caption "Zapisuj wypowiedzi do pliku" -var logging_enabled -parent "Logowanie_grid" -default 1
config add -type lineedit -tab Firewall -caption "o nazwie: " -var logging_file -parent "Logowanie_grid" -default "$kadu(configdir)firewall.log"
}


# Deklaracje zmiennych globalnych:
set asked {}
set scriptpath $module(scriptpath)

on chat0 firewall_resp

proc firewall_resp {uin text time} {

# odczytywanie konfiguracji z pliku i deklaracje innych zmiennych:
set firewall_enabled [configfile read "Firewall" "firewall_enabled"]

set question [configfile read "Firewall" "question"]
set answer  [configfile read "Firewall" "answer"]

set confirmation_send  [configfile read "Firewall" "confirmation_send"]
set confirmation_text  [configfile read "Firewall" "confirmation_text"]

set action  [configfile read "Firewall" "action"]
set groupname [configfile read "Firewall" "groupname"]
set ask_once [configfile read "Firewall" "ask_once"]
set notify_hint [configfile read "Firewall" "notify_hint"]
if { $notify_hint } {
set notify_hint_text [configfile read "Firewall" "notify_hint_text"]
set notify_hint_timeout [configfile read "Firewall" "notify_hint_timeout"]
set notify_hint_fgcolor [configfile read "Firewall" "notify_hint_fgcolor"]
set notify_hint_bgcolor [configfile read "Firewall" "notify_hint_bgcolor"]
}
set logging_enabled [configfile read "Firewall" "logging_enabled"]
set logging_file [configfile read "Firewall" "logging_file"]

global asked
global scriptpath

# Glowne cialo skryptu ;-)  
if { $firewall_enabled && [string first " " $uin] == -1 } {; # Sprawdza czy wlaczony i czy rozmowa to nie konferencja
 
  if { ![user exists $uin] && ![chat exists $uin] } {; # Uzytkownik to anonim
    if { ![string compare -nocase $text $answer] } {; # Sprawdzanie zgodnosci z odpowiedzia
      
      # Akcje do wykonania gdy odpowiedz jest poprawna:
      if { $confirmation_send && $confirmation_text != "" } { msg $uin $confirmation_text }; # Wysylanie potwierdzenia
      if { $action == "addgroup" } { user add -uin $uin -altname $uin -group $groupname; set notify_hint_text "Anonim <b>$uin</b> zosta dodany do grupy <b>$groupname</b>" }; # Dodawanie do grupy + zmiana informacji w dymku
      if { $action == "openchat" } { chat open $uin }; # Otwieranie okna rozmowy
      if { $ask_once } { set position [lsearch -exact $asked $uin]; set asked [lreplace $asked $position $position ] }; # Usuwanie UINa z listy zapytanych
      if { $logging_enabled } { set text "Uytkownik udzielil poprawnej odpowiedzi!\n----------------------------------------------------" }; # Zmiana tekstu do zapisania w logu
      
      # Akcje do wykonania gdy odpowiedz jest zla:
         } elseif {$ask_once} {
     				if { [lsearch -exact $asked $uin] == -1} { msg $uin $question; lappend asked $uin }; # Dopisywanie UINa do listu zapytanych i wysylanie pytania
			      } else { msg $uin $question }; # Wysylanie pytania
	      
    # Parsowanie UINa oraz wyswietlanie dymka z informacja:
    if { $notify_hint } {
                          set uin_position [string first "%u" $notify_hint_text]; # Ustalanie polozenia ciagu %u
			  if { $uin_position != -1 } { set notify_hint_text [string replace $notify_hint_text $uin_position [expr $uin_position + 1] "$uin"] }; # Zamiana %u na $uin
			  hint -icon $scriptpath/firewall.png -bgcolor $notify_hint_bgcolor -fgcolor $notify_hint_fgcolor -timeout $notify_hint_timeout $notify_hint_text; # Wyswietlanie dymka
			}
    
    # Zapis do loga:
    if { $logging_enabled } {
			      if { ![file exists $logging_file] } { set file [open $logging_file a]; puts $file "        DATA I CZAS          ::   UIN   :: WIADOMOSC\n----------------------------------------------------"; close $file }; # Plik logu nie istnieje - zapisywanie naglowka
			      set time_to_write [clock format $time -format %c]; # Formatowanie daty
			      set file [open $logging_file a]; # Otwarcie pliku do dopisywania
			      puts $file "$time_to_write :: $uin :: $text"; # Zapis do pliku
			      close $file; # Zamkniecie pliku
			    }  
    
    # Odrzucenie wiadomosci:
    return 1
    }
   # Przepuszczenie wiadomosci:
   return 0
  }
 # J.w.
 return 0
}


on unloadmodule firewall_unl
proc firewall_unl {} {
# usun sie z okna konfiguracji
config delete Firewall "o nazwie: "
config delete Firewall "Zapisuj wypowiedzi do pliku"
config delete Firewall "Logowanie_grid"
config delete Firewall "Logowanie"

config delete Firewall "Tekst dymka: "
config delete Firewall "Kolor tla dymka"
config delete Firewall "  "
config delete Firewall "Kolor tekstu dymka"
config delete Firewall "Wyswietlaj dymek przez ... sekund: "
config delete Firewall " "
config delete Firewall "Powiadom dymkiem o aktywnosci"
config delete Firewall "Hints_grid"
config delete Firewall "Powiadamianie dymkiem"

config delete Firewall "Nazwa grupy "
config delete Firewall "       "
config delete Firewall "Podejmij akcje: "
config delete Firewall "Akcja_grid"
config delete Firewall "o tresci: "
config delete Firewall "Wyslij potwierdzenie"
config delete Firewall "Potwierdzenie_grid"
config delete Firewall "Po dobrej odpowiedzi" 

config delete Firewall "Odpowiedz "
config delete Firewall "Zadaj pytanie tylko raz"
config delete Firewall "Tekst pytania "
config delete Firewall "Automatyczne pytanie"

config delete Firewall "Firewall wlaczony"
config delete Firewall
}