#ifndef TCLCONSOLE_H
#define TCLCONSOLE_H

#include <qwidget.h>

#include <tcl.h>

class TclLineEdit;
class TclTextEdit;
class QComboBox;

class TclConsole : public QWidget
{
	Q_OBJECT

	public:
		TclConsole();
		TclLineEdit* getCmdLine();
		QComboBox* context();
		void mousePressEvent(QMouseEvent*);
		void puts(QString);

	private:
		TclLineEdit* cmd;
		TclTextEdit* txt;
		QComboBox* cbox;
		Tcl_ChannelType tclConsoleOut;
		Tcl_Channel consoleOutput;

	private slots:
		void exec();
};

#endif
