#ifndef TCLLINEEDIT_H
#define TCLLINEEDIT_H

#include <qlineedit.h>
#include <qstringlist.h>

class QKeyEvent;

class TclLineEdit : public QLineEdit
{
	Q_OBJECT

	public:
		TclLineEdit(QWidget *parent = 0, const char *name = 0);
		void keyPressEvent(QKeyEvent*);
		QStringList history;
		uint consoleHistory;
		uint histCnt;

	private slots:
		void historyUp();
		void historyDown();

	signals:
		void enter();
};

#endif
