#ifndef TCLLISTBOX_H
#define TCLLISTBOX_H

#include <qdialog.h>

class QListBox;
class QLineEdit;
class QLabel;

class TclListBox : public QDialog
{
	Q_OBJECT

	public:
		TclListBox(bool mesg = FALSE);
		void keyPressEvent(QKeyEvent*);
		void setMsg(QString);
		QListBox* list();

	private:
		QLineEdit *toAdd;
		QListBox *_list;
		QLabel *msg;

	private slots:
		void add();
		void del();
		void ok();
		void cancel();
};

#endif
