#ifndef TCLLOADDIALOG_H
#define TCLLOADDIALOG_H

#include <qdialog.h>

class QListBox;
class QListBoxItem;
class QString;

class TclLoadDialog : public QDialog
{
	Q_OBJECT

	public:
		TclLoadDialog();
		void keyPressEvent(QKeyEvent*);
		void setMsg(QString);
		QListBox* list();
		QListBox* lList();
		QListBox* gList();
		bool loaded(QString);

	private:
		QListBox *loaded_list;
		QListBox *global_list;
		QListBox *local_list;
		QString localPath;
		QString globalPath;

	private slots:
		void done();
		void load(int list_type = 0);
		void loadLocal(QListBoxItem*);
		void loadGlobal(QListBoxItem*);
		void unload(QListBoxItem* it = NULL);
		void others();
		void reload();
};

#endif
