#ifndef TCLSTRING_H
#define TCLSTRING_H

#include <tcl.h>

class QString;

class TclString
{
    private:
        Tcl_DString ds;

    public:
        TclString();
        TclString(QString str);
        ~TclString();

        void append(QString);
        void appendElement(QString);
        void listBegin();
        void listEnd();
        int length();
        QString value();
        void setResult(Tcl_Interp*);
        char* dString();
};

#endif
