/***************************************************************************
 *																		 *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or	 *
 *   (at your option) any later version.								   *
 *																		 *
 ***************************************************************************/

#include "tcl_scripting.h"
#include "tcltextedit.h"
#include "tcllineedit.h"
#include "tclconsole.h"

TclTextEdit::TclTextEdit(QWidget *parent, const char *name) : QTextEdit(parent, name)
{
	kdebugf();
	setTextFormat(Qt::PlainText);
}

void TclTextEdit::focusInEvent(QFocusEvent* e)
{
	kdebugf();
	tclSess[0]->console()->getCmdLine()->setFocus();
}
