#ifndef TCLTIMER_H
#define TCLTIMER_H

#include <qtimer.h>

class TclSession;

class TclTimer : public QTimer
{
	Q_OBJECT

	public:
		TclTimer(TclSession*);
		void setCode(QString);
		void currIdent(int);
		void remove();
		void kill();
		void setSingleShot(bool);
		bool isSingleShot();

	private slots:
		void exec();

	private:
		int cid;
		QString code;
		bool ss;
		TclSession* tsess;
};

#endif
